#include "RGBpixmap.h"

void RGBpixmap::readBMPFile(char *fname){
	matrixFlag = true;
	using namespace std;
	ifstream fileBMP;
	BITMAPFILEHEADER bmfh;
	BITMAPINFOHEADER bmih;
	fileBMP.open(fname, ios::binary);
	fileBMP.read(reinterpret_cast<char*>(&bmfh), sizeof(bmfh));	
	fileBMP.read(reinterpret_cast<char*>(&bmih), sizeof(bmih));	
	numCols = bmih.biWidth;
	numRows = bmih.biHeight;
	length = numCols;
	ptr = new Color32[numRows * numCols];
	for(int y = 0; y < getHeight(); y++)
	for(int x = 0; x < getWidth(); x++) {
		fileBMP.read((char*) this->operator()(x, y).ptrComp(2), sizeof(char));
		fileBMP.read((char*) this->operator()(x, y).ptrComp(1), sizeof(char));
		fileBMP.read((char*) this->operator()(x, y).ptrComp(0), sizeof(char));
		this->operator()(x, y).refComp(3) = (GLubyte) 255;
	}
	fileBMP.close();
}

void RGBpixmap::makeCheckerboard() {
	nRows = nCols = 64;
	pixel = new RGBcolor[3 * nRows * nCols];
	if(!pixel) { //cout << "Out of memory!"; return;}
	}
	long count = 0;
	for( int i = 0; i < nRows; i++)
		for( int j=0; j < nCols; j++) {
			int c = (((i / 8) + (j / 8)) % 2) * 255;
			if(c!=0){
				pixel[count].r = c - 50;
				pixel[count].g = c - 50;
			}
			else {
				pixel[count].r = c;
				pixel[count].g = c;
			}
				pixel[count++].b = 180;
		}
}
void RGBpixmap::delCheckerboard() {
	free(pixel);
}

void RGBpixmap::setTexture(void) {
	glGenTextures(1, &name);
	glBindTexture(GL_TEXTURE_2D, name);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, nCols, nRows, 0, GL_RGB, GL_UNSIGNED_BYTE, pixel);
}
void RGBpixmap::setupTexture(void) {
	glGenTextures(1, &name);
	glBindTexture(GL_TEXTURE_2D, name);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, getCols(), getRows(), 0, GL_RGBA, GL_UNSIGNED_BYTE, ptrElem(0, 0));
}
void RGBpixmap::deleteTexture() {
	glDeleteTextures(1, &name);
}