#include "color.h"
#include "matrix.h"
#include <windows.h>
#include <GL/glu.h>
#include <gl/gl.h>
#include <fstream>

class RGBcolor {
public:
	unsigned char r;
	unsigned char g;
	unsigned char b;
};

class RGBpixmap : public Matrix<Color32>{
protected:
	GLuint name;
public:
	int nRows, nCols;
	RGBcolor *pixel;
	void readBMPFile(char *fname);
	RGBpixmap(){ nRows=0; nCols=0;}
	~RGBpixmap(){}
	int getWidth() const;
	int getHeight() const;
	void makeCheckerboard();
	void delCheckerboard();
	void deleteTexture();
	void setTexture(void);
	void setupTexture(void);
	GLuint getName();
};
inline GLuint RGBpixmap::getName() { return name; }

inline int RGBpixmap::getWidth() const { return numCols; }

inline int RGBpixmap::getHeight() const { return numRows; }